/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */

//Title:        JBuilder Tutorial
//Version:      2.0
//Copyright:    Copyright (c) 1998
//Author:       Jens Ole Lauridsen
//Company:      Borland Int'l
//Description:  Tutorial of Distributed Computing using RMI and DataSetData.

package borland.samples.tutorial.dataset.datasetdata;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import borland.jbcl.control.*;
import borland.jbcl.layout.*;
import borland.sql.dataset.*;
import borland.jbcl.dataset.*;

// The ClientFrame is the frame of ClientApp.
// Notice, that the dataSet displayed in the grid is a TableDataSet with
// a custom Provider and a custom Resolver. See ClientProvider and 
// ClientResolver for details.
//
public class ClientFrame extends DecoratedFrame {
  ResourceBundle res = Res.getBundle("borland.samples.tutorial.dataset.datasetdata.Res");
  BorderLayout borderLayout1 = new BorderLayout();
  BevelPanel bevelPanel1 = new BevelPanel();
  borland.jbcl.dataset.TableDataSet tableDataSet1 = new borland.jbcl.dataset.TableDataSet();
  ClientProvider clientProvider1 = new ClientProvider();
  ClientResolver clientResolver1 = new ClientResolver();
  borland.jbcl.control.NavigatorControl navigatorControl1 = new borland.jbcl.control.NavigatorControl();
  borland.jbcl.control.GridControl gridControl1 = new borland.jbcl.control.GridControl();
  java.awt.BorderLayout borderLayout2 = new java.awt.BorderLayout();

  //Construct the frame
  public ClientFrame() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception{
    this.setLayout(borderLayout1);
    this.setSize(new Dimension(500, 300));
    this.setTitle(res.getString("RS_ClientTitle"));
    bevelPanel1.setLayout(borderLayout2);
    this.add(bevelPanel1, BorderLayout.CENTER);
    bevelPanel1.add(navigatorControl1, BorderLayout.NORTH);
    bevelPanel1.add(gridControl1, BorderLayout.CENTER);
    tableDataSet1.setProvider(clientProvider1);
    tableDataSet1.setResolver(clientResolver1);
    navigatorControl1.setDataSet(tableDataSet1);
    gridControl1.setDataSet(tableDataSet1);
  }
}

 
