/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.samples.tutorial.dataset.storproc.procsetup;

import borland.jbcl.dataset.*;
import borland.sql.dataset.*;
import java.sql.*;

public class CreateProcedures {

  public static void main(String[] args) throws DataSetException {
    Database database1 = new Database();
    database1.setConnection(new ConnectionDescriptor("jdbc:odbc:dataset tutorial", "sysdba", "masterkey", false, "sun.jdbc.odbc.JdbcOdbcDriver"));
    try { database1.executeStatement("DROP PROCEDURE GET_COUNTRIES"); } catch (Exception ex) {};
    try { database1.executeStatement("DROP PROCEDURE UPDATE_COUNTRY"); } catch (Exception ex) {};
    try { database1.executeStatement("DROP PROCEDURE INSERT_COUNTRY"); } catch (Exception ex) {};
    try { database1.executeStatement("DROP PROCEDURE DELETE_COUNTRY"); } catch (Exception ex) {};
    database1.executeStatement(getCountriesProc);
    database1.executeStatement(updateProc);
    database1.executeStatement(deleteProc);
    database1.executeStatement(insertProc);
    database1.closeConnection();
  }                                            

  static final String getCountriesProc = 
  
"CREATE PROCEDURE GET_COUNTRIES RETURNS (     \r\n"+
"  COUNTRY VARCHAR(15),                       \r\n"+
"  CURRENCY VARCHAR(10) ) AS                  \r\n"+
"BEGIN                                        \r\n"+
" FOR SELECT c.country, c.currency            \r\n"+
"  FROM country c                             \r\n"+
"  INTO :COUNTRY,:CURRENCY                    \r\n"+
" DO                                          \r\n"+
" BEGIN                                       \r\n"+
"  SUSPEND;                                   \r\n"+
" END                                         \r\n"+
"END;";


  
  static final String updateProc = 
  
"CREATE PROCEDURE UPDATE_COUNTRY(             \r\n"+
"  OLD_COUNTRY VARCHAR(15),                   \r\n"+
"  NEW_COUNTRY VARCHAR(15),                   \r\n"+
"  NEW_CURRENCY VARCHAR(20) ) AS              \r\n"+
"BEGIN                                        \r\n"+
"  UPDATE country                             \r\n"+
"    SET country = :NEW_COUNTRY               \r\n"+
"    WHERE country = :OLD_COUNTRY;            \r\n"+
"END;";



  static final String insertProc = 
  
"CREATE PROCEDURE INSERT_COUNTRY(             \r\n"+
"  NEW_COUNTRY VARCHAR(15),                   \r\n"+
"  NEW_CURRENCY VARCHAR(20) ) AS              \r\n"+
"BEGIN                                        \r\n"+
"  INSERT INTO country(country,currency)      \r\n"+
"    VALUES (:NEW_COUNTRY,:NEW_CURRENCY);     \r\n"+
"END;";


  static final String deleteProc = 
  
"CREATE PROCEDURE DELETE_COUNTRY(             \r\n"+
"  OLD_COUNTRY VARCHAR(15) ) AS               \r\n"+
"BEGIN                                        \r\n"+
"  DELETE FROM country                        \r\n"+
"    WHERE country = :OLD_COUNTRY;            \r\n"+
"END;";
}                           
