/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */


package borland.samples.tutorial.dataset.providers;

import borland.jbcl.util.Variant;

// interface DataLayout
//   Contains column definitions of "data.txt".
//
interface DataLayout {
  static final int      COLUMN_COUNT    = 6;
  static final int[]    COLUMN_WIDTHS   = {  6,
                                             9,
                                            12,
                                            18,
                                             4,
                                             9 };
                                            
  static final String[] COLUMN_NAMES    = { "ID",
                                            "Brand",
                                            "Sport",
                                            "Model",
                                            "Year",
                                            "Price" };
                                           
  static final String[] COLUMN_CAPTIONS = { "ID",
                                            "Brand",
                                            "Kind of Sport",
                                            "Model",
                                            "Year of Purchase",
                                            "Original Price" };
                                           
  static final int[]    COLUMN_TYPES    = { Variant.INT,
                                            Variant.STRING, 
                                            Variant.STRING, 
                                            Variant.STRING, 
                                            Variant.INT, 
                                            Variant.BIGDECIMAL };

  static final String   ROWID_NAME      = COLUMN_NAMES[0];
}
