/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.samples.intl.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import borland.jbcl.layout.*;
import borland.jbcl.control.*;
import borland.jbcl.dataset.*;

import borland.samples.intl.application.*;
import borland.samples.intl.beans.event.*;

/*
 * Interface implemented by customer information panels which
 * are loaded into the ShipToPanel panel and SoldToPanel panel
 * within the OrderFrame frame.
 * Implements LocaleChangeListener in the event that this
 * panel is found to be the closest match for the newly
 * selected language, but for a different country.  For
 * example, CustomerInfoPanel.java is the default panel for countries
 * for whose language and country a localized CustomerInfoPanel
 * does not exist.  When a locale change occurs, it should
 * attempt to reload its localizable strings from the new locale's
 * resource bundle in case only the strings were localized.
 * Because the caller is responsible for loading this panel,
 * the caller is also responsible for registering and
 * deregistering this panel with the system LocaleChangeManager.
 */
public interface InterchangeableCustomerInfoPanel extends LocaleChangeListener {
  public void setDataSet(DataSet dataSet);
  public void setReadOnly(boolean readOnly);
}

