/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.samples.intl.beans;

import java.awt.*;

public class InternationalClockAlignmentEditor
                extends java.beans.PropertyEditorSupport {

  int style;

  public String[] getTags() {
    String result[] = {
      "LEFT",
      "CENTER",
      "RIGHT",
    };
    return result;
  }

  public String getJavaInitializationString() {
    switch (style) {
    case Label.CENTER:
      return "java.awt.Label.CENTER";
    case Label.RIGHT:
      return "java.awt.Label.RIGHT";
    default:
      return "java.awt.Label.LEFT";
    }
  }

  public void setAsText(String text) {
    if (text.equals("CENTER")) {
      style = Label.CENTER;
    } else if (text.equals("RIGHT")) {
      style = Label.RIGHT;
    } else {
      style = Label.LEFT;
    }
  }

  public String getAsText() {
    switch (style) {
    case Label.CENTER:
      return "CENTER";
    case Label.RIGHT:
      return "RIGHT";
    default:
      return "LEFT";
    }
  }

  public void setValue(Object o) {
    style = ((Integer) o).intValue();
    firePropertyChange();
  }

  public Object getValue() {
    return new Integer(style);
  }

}

