/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.samples.intl.beans;

import java.awt.*;
import java.awt.event.*;
import borland.jbcl.control.*;
import java.io.*;
import java.net.*;
import java.util.*;

/**
 * Frame which shows an image and displays an hourglass
 * cursor and centers itself on the user's screen 
 * while the application is loading.
 * Should be called by loadingFrame.setVisible(true)
 * and disposed of (loadingFrame.dispose()) after
 * the application has loaded.
 */
public class LoadingFrame extends Frame {
  ImageControl imageControl1 = new ImageControl();
  BorderLayout borderLayout1 = new BorderLayout();

  public LoadingFrame() {
    try {
      // Set the hourglass cursor for this frame.
      setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void setVisible(boolean visible) {
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    pack();
    Dimension frameSize = getPreferredSize();
    setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    super.setVisible(visible);
  }

  private void jbInit() throws Exception{
    this.setLayout(borderLayout1);
    this.add(imageControl1, BorderLayout.CENTER);
  }

  public void setImageName(String path) throws IOException {
    imageControl1.setImageName(path);
  }

  public String getImageName() {
    return imageControl1.getImageName();
  }

  public void setImage(Image image) throws IOException {
    imageControl1.setImage(image);
  }

  public Image getImage() {
    return imageControl1.getImage();
  }

  public void setImageURL(URL url) throws IOException {
    imageControl1.setImageURL(url);
  }

  public URL getImageURL() {
    return imageControl1.getImageURL();
  }

}
