/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.samples.intl.beans;

import java.beans.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import borland.jbcl.model.*;

public class LocaleChooserMultipleLocaleSelector extends LocaleChooserLocaleSelector {

  public LocaleChooserMultipleLocaleSelector() {
    localeChooser.setAllowMultiSelect(true);
  }

  public String getJavaInitializationString() {
    Locale [] locale = localeChooser.getSelectedLocales();

    String localeInitString = "new java.util.Locale [] {\n";
    for (int i = 0; i < locale.length; i++) {
      localeInitString += "new java.util.Locale(\"" + locale[i].getLanguage() + "\", \"";
      if (locale[i].getCountry().length() == 0) {
        localeInitString += "\")";
      } else {
        localeInitString += locale[i].getCountry() + "\"";
        if (locale[i].getVariant().length() == 0) {
          localeInitString += ")";
        } else {
          localeInitString += ",\"" + locale[i].getVariant() + "\")";
        }
      }
      localeInitString += ",\n";
    }
    localeInitString += " } ";
//    System.out.println(localeInitString + "\n:" + this.getClass().getName() + ".getJavaInitializationString()");
    return localeInitString;
  }

  public void setValue(Object o) {
    try {
      Locale [] locale = (Locale []) ((Locale []) o).clone();
      for (int i = 0; i < locale.length; i++) {
//        System.out.print(locale[i]+";");
      }
//      System.out.println(":" + this.getClass().getName() +".setValue()");
      localeChooser.setSelectedLocales(locale);
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  public Object getValue() {
    Locale [] l = localeChooser.getSelectedLocales();
    for (int i = 0; i < l.length; i++) {
//      System.out.println(l[i]);
    }
//    System.out.println(":" + this.getClass().getName() + ".getValue()");
    return localeChooser.getSelectedLocales();
  }

  public String getAsText() {
//    System.out.println(this.getClass().getName() + ".getAsText():");
    return getJavaInitializationString();
  }
}
