/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.samples.tutorial.dataset.paramquery;

import java.awt.*;
import java.awt.event.*;
import borland.jbcl.control.*;
import borland.jbcl.layout.*;
import borland.sql.dataset.*;
import borland.jbcl.dataset.*;

public class ParamQuery_Frame1 extends DecoratedFrame {
  BevelPanel bevelPanel1 = new BevelPanel();
  Database database1 = new Database();
  ParameterRow parameterRow1 = new ParameterRow();
  Column column1 = new Column();
  Column column2 = new Column();
  QueryDataSet queryDataSet1 = new QueryDataSet();
  GridControl gridControl1 = new GridControl();
  BorderLayout borderLayout1 = new BorderLayout();
  TextField textField3 = new TextField();
  TextField textField4 = new TextField();
  TextControl textControl1 = new TextControl();
  TextControl textControl2 = new TextControl();
  NavigatorControl navigatorControl1 = new NavigatorControl();
  BevelPanel bevelPanel2 = new BevelPanel();
  BevelPanel bevelPanel3 = new BevelPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  FlowLayout flowLayout1 = new FlowLayout();
  FlowLayout flowLayout2 = new FlowLayout();

  //Construct the frame
  public ParamQuery_Frame1() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception{
    this.setLayout(borderLayout1);
    this.setSize(new Dimension(470, 302));
    this.setTitle("Frame Title");
    database1.setConnection(new borland.sql.dataset.ConnectionDescriptor("jdbc:odbc:dataset tutorial", "SYSDBA", "masterkey", false, "sun.jdbc.odbc.JdbcOdbcDriver"));
    column1.setColumnName("low_no");
    column1.setDataType(borland.jbcl.util.Variant.INT);
    column1.setDefault("15");
    column2.setColumnName("high_no");
    column2.setDataType(borland.jbcl.util.Variant.INT);
    column2.setDefault("50");
    queryDataSet1.setQuery(new borland.sql.dataset.QueryDescriptor(database1, "select * from employee where emp_no > :low_no and emp_no < :high_no", parameterRow1, true, Load.ALL));
    gridControl1.setDefaultColumnWidth(75);
    gridControl1.setDataSet(queryDataSet1);
    textField3.setColumns(6);
    textField4.setColumns(6);
    textControl1.setText("Low:");
    textControl2.setText("    High:");
    navigatorControl1.setDataSet(queryDataSet1);
    bevelPanel2.setBevelInner(BevelPanel.FLAT);
    bevelPanel3.setBevelInner(BevelPanel.FLAT);
    bevelPanel2.setLayout(flowLayout2);
    bevelPanel3.setLayout(flowLayout1);
    textField4.addKeyListener(new ParamQuery_Frame1_textField4_keyAdapter(this));
    textField3.addKeyListener(new ParamQuery_Frame1_textField3_keyAdapter(this));
    bevelPanel1.setLayout(borderLayout2);
    this.add(bevelPanel1, BorderLayout.NORTH);
    bevelPanel1.add(bevelPanel2, BorderLayout.NORTH);
    bevelPanel2.add(navigatorControl1, null);
    bevelPanel1.add(bevelPanel3, BorderLayout.CENTER);
    bevelPanel3.add(textControl1, null);
    bevelPanel3.add(textField3, null);
    bevelPanel3.add(textControl2, null);
    bevelPanel3.add(textField4, null);
    this.add(gridControl1, BorderLayout.CENTER);
    parameterRow1.setColumns(new Column[] {column1, column2});
  }

  
  void textField3_keyPressed(KeyEvent e) {
    if (e.getKeyCode() == KeyEvent.VK_ENTER){
    try{
    parameterRow1.setInt("low_no", Integer.parseInt(textField3.getText()));
    queryDataSet1.refresh();
    }
    catch (Exception ex){
    ex.printStackTrace();
    } }
  }

  void textField4_keyPressed(KeyEvent e) {
    if (e.getKeyCode() == KeyEvent.VK_ENTER){
    try{
    parameterRow1.setInt("high_no", Integer.parseInt(textField4.getText()));
    queryDataSet1.refresh();
    }
    catch (Exception ex){
    ex.printStackTrace();
    }
  } }   }



class ParamQuery_Frame1_textField3_keyAdapter extends java.awt.event.KeyAdapter {
  ParamQuery_Frame1 adaptee;

  ParamQuery_Frame1_textField3_keyAdapter(ParamQuery_Frame1 adaptee) {
    this.adaptee = adaptee;
  }

  public void keyPressed(KeyEvent e) {
    adaptee.textField3_keyPressed(e);
  }
}

class ParamQuery_Frame1_textField4_keyAdapter extends java.awt.event.KeyAdapter {
  ParamQuery_Frame1 adaptee;

  ParamQuery_Frame1_textField4_keyAdapter(ParamQuery_Frame1 adaptee) {
    this.adaptee = adaptee;
  }

  public void keyPressed(KeyEvent e) {
    adaptee.textField4_keyPressed(e);
  }
}
