/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.samples.rmi.simple;

import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.server.*;
import java.util.Date;

public class SimpleRMIClient
{

  public static void main(String[] argv) {
    String serverName = "";
    System.setSecurityManager(new RMISecurityManager());
    if (argv.length != 1) {
      try {
        serverName = java.net.InetAddress.getLocalHost().getHostName();
      }
      catch(Exception e) {
        e.printStackTrace();
      }
    }
    else {
      serverName = argv[0];
    }

    if (serverName == "") {
      System.out.println("usage: java SimpleRMIClient <IP address of host running RMI server>");
      System.exit(0);
    }

    try {
      //bind server object to object in client
      SimpleRMIInterface myServerObject = (SimpleRMIInterface) Naming.lookup("rmi://"+serverName+"/SimpleRMIImpl instance");

      //invoke method on server object
      Date d = myServerObject.getDate();
      System.out.println("Date on server is " + d);
    }
    catch(Exception e) {
      System.out.println("Exception occured: " + e);
      System.exit(0);
    }
    System.out.println("RMI connection successful");
  }
}
