/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */

//Title:        Stored Procedure Sample
//Version:      2.0
//Copyright:    Copyright (c) 1998
//Company:      Borland Int'l
//Description:  DataModule with ProcedureDataSet and ProcedureResolver


package borland.samples.tutorial.dataset.storedprocedure;

import java.awt.*;
import java.awt.event.*;
import borland.jbcl.layout.*;
import borland.jbcl.control.*;
import borland.jbcl.dataset.*;
import borland.sql.dataset.*;

public class StoredProcedureDM implements DataModule{
  private static StoredProcedureDM myDM;
  Database currentDatabase = new Database();
  QueryDataSet masterQDS = new QueryDataSet();
  ProcedureDataSet detailPDS = new ProcedureDataSet();
  ProcedureResolver detailPR = new ProcedureResolver();
  Column column1 = new Column();


// InterBase via Visigenic ODBC:
  final String  url         = "jdbc:odbc:dataset tutorial";
  final String  driver      = "sun.jdbc.odbc.JdbcOdbcDriver";
  final String  ddlFile     = "sqlInterbase.sql";
  final String  ddlDropFile = "sqlDrop.sql";
  final boolean acceptCR    = true;
  final boolean semiColon   = false;       
  final String  username    = "sysdba";
  final String  password    = "masterkey";
  final String  masterQuery = "select * from SAMPLEDEPT";
  final String  callProvide = "select * from SAMPLEEMPINFO(:DEPTID)";
  final String  callInsert  = "execute procedure SAMPLEINSEMP :EMPID, :FNAME, :LNAME, :DHIRE, :SALARY, :PARAMETER.DEPTID";
  final String  callUpdate  = "execute procedure SAMPLEUPDEMP :ORIGINAL.EMPID, :EMPID, :FNAME, :LNAME, :DHIRE, :SALARY, :DEPTID";
  final String  callDelete  = "execute procedure SAMPLEDELEMP :EMPID";

/*  
// InterBase via InterClient:
  final String  url         = "jdbc:interbase://LOCALHOST/c:/Program Files/Borland/IntrBase/Examples/employee.gdb";
  final String  driver      = "interbase.interclient.Driver";
  final String  ddlFile     = "sqlInterbase.sql";
  final String  ddlDropFile = "sqlDrop.sql";
  final boolean acceptCR    = true;
  final boolean semiColon   = false;       
  final String  username    = "sysdba";
  final String  password    = "masterkey";
  final String  masterQuery = "select * from SAMPLEDEPT";
  final String  callProvide = "select * from SAMPLEEMPINFO(:DEPTID)";
  final String  callInsert  = "execute procedure SAMPLEINSEMP :EMPID, :FNAME, :LNAME, :DHIRE, :SALARY, :PARAMETER.DEPTID";
  final String  callUpdate  = "execute procedure SAMPLEUPDEMP :ORIGINAL.EMPID, :EMPID, :FNAME, :LNAME, :DHIRE, :SALARY, :DEPTID";
  final String  callDelete  = "execute procedure SAMPLEDELEMP :EMPID";

/*
// Oracle via Oracle JDBC:
  final String  url         = "jdbc:oracle:thin:@ipgora:1526:ORCL";
  final String  driver      = "oracle.jdbc.driver.OracleDriver";
  final String  ddlFile     = "sqlOracle.sql";
  final String  ddlDropFile = "sqlDrop.sql";
  final boolean acceptCR    = false;
  final boolean semiColon   = true;       
  final String  username    = "scott";
  final String  password    = "tiger";
  final String  masterQuery = "select * from SAMPLEDEPT";
  final String  callProvide = "{?=call SAMPLEEMPINFO(:DEPTID)}";
  final String  callInsert  = "{call SAMPLEINSEMP(:EMPID, :FNAME, :LNAME, :HIREDATE, :SALARY, :PARAMETER.DEPTID)}";
  final String  callUpdate  = "{call SAMPLEUPDEMP(:ORIGINAL.EMPID, :EMPID, :FNAME, :LNAME, :HIREDATE, :SALARY, :DEPTID)}";
  final String  callDelete  = "{call SAMPLEDELEMP(:EMPID)}";
*/
/*                                   
// Sybase via JConnect:
  final String  url         = "jdbc:sybase:Tds:ipgsyb:2025";
  final String  driver      = "com.sybase.jdbc.SybDriver";
  final String  ddlFile     = "sqlSybase.sql";
  final String  ddlDropFile = "sqlDrop.sql";
  final boolean acceptCR    = true;
  final boolean semiColon   = false;       
  final String  username    = "sa";
  final String  password    = "";
  final String  masterQuery = "select * from SAMPLEDEPT";
  final String  callProvide = "{call SAMPLEEMPINFO(:DEPTID)}";
  final String  callInsert  = "{call SAMPLEINSEMP(:EMPID, :FNAME, :LNAME, :HIREDATE, :SALARY, :PARAMETER.DEPTID)}";
  final String  callUpdate  = "{call SAMPLEUPDEMP(:ORIGINAL.EMPID, :EMPID, :FNAME, :LNAME, :HIREDATE, :SALARY, :DEPTID)}";
  final String  callDelete  = "{call SAMPLEDELEMP(:EMPID)}";
*/                                   

  public StoredProcedureDM() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception{
    currentDatabase.setConnection(new borland.sql.dataset.ConnectionDescriptor(url, username, password, false, driver));
    masterQDS.setQuery(new borland.sql.dataset.QueryDescriptor(currentDatabase, masterQuery, null, true, Load.ALL));
    column1.setColumnName("EMPID");
    column1.setRowId(true);
    detailPDS.setProcedure(new borland.sql.dataset.ProcedureDescriptor(currentDatabase, callProvide, masterQDS, true, Load.ALL));
    detailPDS.setResolver(detailPR);
    detailPDS.setColumns(new Column[] {column1});
    detailPR.setDatabase(currentDatabase);
    detailPR.setInsertProcedure(new borland.sql.dataset.ProcedureDescriptor(currentDatabase, callInsert, masterQDS, true, Load.ALL));
    detailPR.setUpdateProcedure(new borland.sql.dataset.ProcedureDescriptor(currentDatabase, callUpdate, masterQDS, true, Load.ALL));
    detailPR.setDeleteProcedure(new borland.sql.dataset.ProcedureDescriptor(currentDatabase, callDelete, null, true, Load.ALL));
  }
   
  public static StoredProcedureDM getDataModule() {
//    return new StoredProcedureDM();
    if (myDM == null)
      myDM = new StoredProcedureDM();
    return myDM;
  }

  public boolean isAcceptCR() {
    return acceptCR;
  }

  public boolean isKeepSemiColon() {
    return semiColon;
  }
  public String getDDLquery() {
    return ddlFile;
  }

  public String getDropDDLquery() {
    return ddlDropFile;
  }

  public borland.sql.dataset.Database getCurrentDatabase() {
    return currentDatabase;
  }

  public borland.sql.dataset.ProcedureDataSet getDetailPDS() {
    return detailPDS;
  }

  public borland.sql.dataset.QueryDataSet getMasterQDS() {
    return masterQDS;
  }
}
