
//Title:        Stored Procedure Sample
//Version:      2.0
//Copyright:    Copyright (c) 1998
//Company:      Borland Int'l
//Description:  This is the SQL definitions for Oracle.


DROP FUNCTION  SAMPLEEMPINFO;
DROP PROCEDURE SAMPLEINSEMP;
DROP PROCEDURE SAMPLEUPDEMP;
DROP PROCEDURE SAMPLEDELEMP;
DROP PROCEDURE SAMPLEUPDSALARY;
DROP TABLE SAMPLEDEPT;
DROP TABLE SAMPLEEMP;

CREATE TABLE SAMPLEEMP
( 
  EMPID    INTEGER NOT NULL,
  FNAME    CHAR(20),
  LNAME    VARCHAR(20),
  HIREDATE DATE,
  SALARY   NUMERIC(15,3),
  DEPTID   INTEGER,

  PRIMARY KEY (EMPID)
);
                                
CREATE TABLE SAMPLEDEPT
(
  DEPTID   INTEGER NOT NULL UNIQUE,
  DNAME    CHAR(25)
);

CREATE FUNCTION SAMPLEEMPINFO( DEPT SAMPLEEMP.DEPTID%TYPE ) RETURN rcSAMPLEEMP AS
   type recEMP is record (
     EMPID    SAMPLEEMP.EMPID%TYPE, 
     LNAME    SAMPLEEMP.LNAME%TYPE, 
     FNAME    SAMPLEEMP.FNAME%TYPE, 
     HIREDATE SAMPLEEMP.HIREDATE%TYPE, 
     SALARY   SAMPLEEMP.SALARY%TYPE );
  type rcSAMPLEEMP is ref cursor return recEMP; 
  rc   rcSAMPLEEMP;
BEGIN
  open rc for select EMPID,LNAME,FNAME,HIREDATE,SALARY from SAMPLEEMP where DEPTID = DEPT;
  return rc;
END;

CREATE PROCEDURE SAMPLEINSEMP (
  EMP_ID SAMPLEEMP.EMPID%TYPE,
  F_NAME SAMPLEEMP.FNAME%TYPE,
  L_NAME SAMPLEEMP.LNAME%TYPE,
  DHIRE  SAMPLEEMP.HIREDATE%TYPE,
  SAL    SAMPLEEMP.SALARY%TYPE,
  DEPT   SAMPLEEMP.DEPTID%TYPE ) AS 
BEGIN
  INSERT INTO SAMPLEEMP VALUES (EMP_ID, F_NAME, L_NAME, DHIRE, SAL, DEPT);
END;

CREATE PROCEDURE SAMPLEUPDEMP (
  OLD_ID SAMPLEEMP.EMPID%TYPE,
  EMP_ID SAMPLEEMP.EMPID%TYPE,
  F_NAME SAMPLEEMP.FNAME%TYPE,
  L_NAME SAMPLEEMP.LNAME%TYPE,
  DHIRE  SAMPLEEMP.HIREDATE%TYPE,
  SAL    SAMPLEEMP.SALARY%TYPE,
  DEPT   SAMPLEEMP.DEPTID%TYPE ) AS 
BEGIN
  UPDATE SAMPLEEMP
    SET
      EMPID    = EMP_ID, 
      FNAME    = F_NAME,
      LNAME    = L_NAME,
      HIREDATE = DHIRE,
      SALARY   = SAL,
      DEPTID   = DEPT
    WHERE
      EMPID    = OLD_ID;
END;

CREATE PROCEDURE SAMPLEUPDSALARY ( EMP_ID SAMPLEEMP.EMPID%TYPE, INCREASE SAMPLEEMP.SALARY%TYPE ) AS 
BEGIN
  UPDATE SAMPLEEMP SET  SALARY = SALARY + INCREASE
    WHERE EMPID = EMP_ID;
END;

CREATE PROCEDURE SAMPLEDELEMP ( EMP_ID SAMPLEEMP.EMPID%TYPE ) AS 
BEGIN
  DELETE FROM SAMPLEEMP WHERE EMPID = EMP_ID;
END;

//  
// Values for SAMPLEEMP :
//

INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (2,   'Roberto',     'lname',        '28-DEC-88', 70000.00,  600);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (4,   'Bruce',       'Young',        '28-DEC-88', 40000.00,  621);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (5,   'Kim',         'Lambert',      '06-FEB-89', 32000.00,  130);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (8,   'Leslie',      'Johnson',      '05-APR-89', 13050.00,  180);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (9,   'Phil',        'Forest',       '17-APR-89', 67300.00,  622);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (11,  'K. J.',       'Weston',       '17-JAN-90', 100000.00, 130);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (12,  'Terri',       'Lee',          '01-MAY-90', 79000.00,  000);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (14,  'Stewart',     'Hall',         '04-JUN-90', 89000.00,  900);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (15,  'Katherine',   'Young',        '14-JUN-90', 38888.00,  623);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (20,  'Chris',       'Papadopoulos', '01-JAN-90', 47566.00,  671);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (24,  'Pete',        'Fisher',       '12-SEP-90', 53000.00,  671);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (28,  'Ann',         'Bennet',       '01-FEB-91', 23000.00,  120);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (29,  'Roger',       'De Souza',     '18-FEB-91', 19000.00,  623);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (34,  'Janet',       'Baldwin',      '21-MAR-91', 93000.00,  110);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (36,  'Roger',       'Reeves',       '25-APR-91', 34000.00,  120);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (37,  'Willie',      'Stansbury',    '25-APR-91', 23000.00,  120);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (44,  'Leslie',      'Phong',        '03-JUN-91', 59000.00,  623);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (45,  'Ashok',       'Ramanathan',   '01-AUG-91', 73000.00,  621);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (46,  'Walter',      'Steadman',     '09-AUG-91', 27777.00,  900);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (52,  'Carol',       'Nordstrom',    '02-OCT-91', 45000.00,  180);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (61,  'Luke',        'Leung',        '18-FEB-92', 44000.00,  110);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (71,  'Jennifer M.', 'Burbank',      '15-APR-92', 43000.00,  622);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (72,  'Claudia',     'Sutherland',   '20-APR-92', 28000.00,  140);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (83,  'Dana',        'Bishop',       '01-JUN-92', 89000.00,  621);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (85,  'Mary S.',     'MacDonald',    '01-JUN-92', 24000.00,  100);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (94,  'Randy',       'Williams',     '08-AUG-92', 39000.00,  672);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (105, 'Oliver H.',   'Bender',       '08-OCT-92', 200000.00, 000);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (107, 'Kevin',       'Cook',         '01-FEB-93', 120000.00, 670);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (109, 'Kelly',       'Brown',        '04-FEB-93', 60000.00,  600);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (110, 'Yuki',        'Ichida',       '04-FEB-93', 32000.00,  115);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (113, 'Mary',        'Page',         '12-APR-93', 31000.00,  671);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (114, 'Bill',        'Parker',       '01-JUN-93', 23000.00,  623);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (118, 'Takashi',     'Yamamoto',     '01-JUL-93', 21000.00,  115);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (121, 'Roberto',     'Ferrari',      '12-JUL-93', 19000.00,  125);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (127, 'Michael',     'Yanowski',     '09-AUG-93', 16000.00,  100);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (134, 'Jacques',     'Glon',         '23-AUG-93', 17000.00,  123);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (136, 'Scott',       'Johnson',      '13-SEP-93', 34000.00,  623);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (138, 'T.J.',        'Green',        '01-NOV-93', 45000.00,  621);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (141, 'Pierre',      'Osborne',      '03-JAN-94', 56000.00,  121);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (144, 'John',        'Montgomery',   '30-MAR-94', 32000.00,  672);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (145, 'Mark',        'Guckenheimer', '02-MAY-94', 32000.00,  622);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (146, 'Lynn',        'Kemper',       '31-OCT-97', 56000.00,  622);


//
// Values for SAMPLEDEPTID :
//
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 000, 'Corporate Headquarters');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 100, 'Sales and Marketing');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 600, 'Engineering');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 900, 'Finance');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 180, 'Marketing');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 620, 'Software Products Div.');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 621, 'Software Development');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 622, 'Quality Assurance');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 623, 'Customer Support');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 670, 'Consumer Electronics Div.');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 671, 'Research and Development');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 672, 'Customer Services');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 130, 'Field Office: East Coast');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 140, 'Field Office: Canada');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 110, 'Pacific Rim Headquarters');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 115, 'Field Office: Japan');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 116, 'Field Office: Singapore');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 120, 'European Headquarters');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 121, 'Field Office: Switzerland');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 123, 'Field Office: France');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 125, 'Field Office: Italy');

