
//Title:        Stored Procedure Sample
//Version:      2.0
//Copyright:    Copyright (c) 1998
//Company:      Borland Int'l
//Description:  This is the SQL definitions for Sybase.
//              The sp_procxmode allows the resolution procedures to be
//              called with autoCommit set to off. JBuilder will set
//              autoCommit off while saving changes.


DROP PROCEDURE SAMPLEEMPINFO;
DROP PROCEDURE SAMPLEINSEMP;
DROP PROCEDURE SAMPLEUPDEMP;
DROP PROCEDURE SAMPLEDELEMP;
DROP PROCEDURE SAMPLEUPDSALARY;
DROP TABLE SAMPLEDEPT;
DROP TABLE SAMPLEEMP;

CREATE TABLE SAMPLEEMP
( 
  EMPID    INTEGER NOT NULL,
  FNAME    CHAR(20),
  LNAME    VARCHAR(20),
  HIREDATE DATETIME,
  SALARY   NUMERIC(15,3),
  DEPTID   INTEGER,

  PRIMARY KEY (EMPID)
);
                                
CREATE TABLE SAMPLEDEPT
(
  DEPTID   INTEGER NOT NULL UNIQUE,
  DNAME    CHAR(25)
);

CREATE PROCEDURE SAMPLEEMPINFO( @DEPT INTEGER ) AS
BEGIN 
  SELECT EMPID,LNAME,FNAME,HIREDATE,SALARY 
    FROM SAMPLEEMP
    WHERE DEPTID = @DEPT
END;
sp_procxmode SAMPLEEMPINFO, 'anymode';

CREATE PROCEDURE SAMPLEINSEMP (
  @EMP_ID INTEGER,
  @FNAME  VARCHAR(20),
  @LNAME  VARCHAR(20),
  @DHIRE  DATETIME,
  @SALARY NUMERIC(15,3),
  @DEPT   INTEGER ) AS 
BEGIN
  INSERT INTO SAMPLEEMP VALUES (@EMP_ID, @FNAME, @LNAME, @DHIRE, @SALARY, @DEPT)
END;
sp_procxmode SAMPLEINSEMP, 'anymode';

CREATE PROCEDURE SAMPLEUPDEMP (
  @OLD_ID INTEGER,
  @EMP_ID INTEGER,
  @FNAME  VARCHAR(20),
  @LNAME  VARCHAR(20),
  @DHIRE  DATETIME,
  @SALARY NUMERIC(15,3),
  @DEPT   INTEGER ) AS 
BEGIN
  UPDATE SAMPLEEMP
    SET
      EMPID    = @EMP_ID, 
      FNAME    = @FNAME,
      LNAME    = @LNAME,
      HIREDATE = @DHIRE,
      SALARY   = @SALARY,
      DEPTID   = @DEPT
    WHERE
      EMPID    = @OLD_ID
END;
sp_procxmode SAMPLEUPDEMP, 'anymode';

CREATE PROCEDURE SAMPLEUPDSALARY ( @EMP_ID INTEGER, @INCREASE NUMERIC(15,3) ) AS 
BEGIN
  UPDATE SAMPLEEMP SET  SALARY = SALARY + @INCREASE
    WHERE EMPID = @EMP_ID
END;
sp_procxmode SAMPLEUPDSALARY, 'anymode';

CREATE PROCEDURE SAMPLEDELEMP ( @EMP_ID INTEGER ) AS 
BEGIN
  DELETE FROM SAMPLEEMP WHERE EMPID = @EMP_ID
END;
sp_procxmode SAMPLEDELEMP, 'anymode';

//  
// Values for SAMPLEEMP :
//

INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (2,   'Roberto',     'lname',        '12/28/1988', 70000.00,  600);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (4,   'Bruce',       'Young',        '12/28/1988', 40000.00,  621);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (5,   'Kim',         'Lambert',      '02/06/1989', 32000.00,  130);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (8,   'Leslie',      'Johnson',      '04/05/1989', 13050.00,  180);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (9,   'Phil',        'Forest',       '04/17/1989', 67300.00,  622);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (11,  'K. J.',       'Weston',       '01/17/1990', 100000.00, 130);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (12,  'Terri',       'Lee',          '05/01/1990', 79000.00,  000);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (14,  'Stewart',     'Hall',         '06/04/1990', 89000.00,  900);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (15,  'Katherine',   'Young',        '06/14/1990', 38888.00,  623);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (20,  'Chris',       'Papadopoulos', '01/01/1990', 47566.00,  671);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (24,  'Pete',        'Fisher',       '09/12/1990', 53000.00,  671);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (28,  'Ann',         'Bennet',       '02/01/1991', 23000.00,  120);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (29,  'Roger',       'De Souza',     '02/18/1991', 19000.00,  623);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (34,  'Janet',       'Baldwin',      '03/21/1991', 93000.00,  110);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (36,  'Roger',       'Reeves',       '04/25/1991', 34000.00,  120);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (37,  'Willie',      'Stansbury',    '04/25/1991', 23000.00,  120);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (44,  'Leslie',      'Phong',        '06/03/1991', 59000.00,  623);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (45,  'Ashok',       'Ramanathan',   '08/01/1991', 73000.00,  621);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (46,  'Walter',      'Steadman',     '08/09/1991', 27777.00,  900);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (52,  'Carol',       'Nordstrom',    '10/02/1991', 45000.00,  180);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (61,  'Luke',        'Leung',        '02/18/1992', 44000.00,  110);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (71,  'Jennifer M.', 'Burbank',      '04/15/1992', 43000.00,  622);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (72,  'Claudia',     'Sutherland',   '04/20/1992', 28000.00,  140);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (83,  'Dana',        'Bishop',       '06/01/1992', 89000.00,  621);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (85,  'Mary S.',     'MacDonald',    '06/01/1992', 24000.00,  100);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (94,  'Randy',       'Williams',     '08/08/1992', 39000.00,  672);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (105, 'Oliver H.',   'Bender',       '10/08/1992', 200000.00, 000);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (107, 'Kevin',       'Cook',         '02/01/1993', 120000.00, 670);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (109, 'Kelly',       'Brown',        '02/04/1993', 60000.00,  600);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (110, 'Yuki',        'Ichida',       '02/04/1993', 32000.00,  115);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (113, 'Mary',        'Page',         '04/12/1993', 31000.00,  671);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (114, 'Bill',        'Parker',       '06/01/1993', 23000.00,  623);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (118, 'Takashi',     'Yamamoto',     '07/01/1993', 21000.00,  115);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (121, 'Roberto',     'Ferrari',      '07/12/1993', 19000.00,  125);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (127, 'Michael',     'Yanowski',     '08/09/1993', 16000.00,  100);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (134, 'Jacques',     'Glon',         '08/23/1993', 17000.00,  123);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (136, 'Scott',       'Johnson',      '09/13/1993', 34000.00,  623);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (138, 'T.J.',        'Green',        '11/01/1993', 45000.00,  621);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (141, 'Pierre',      'Osborne',      '01/03/1994', 56000.00,  121);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (144, 'John',        'Montgomery',   '03/30/1994', 32000.00,  672);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (145, 'Mark',        'Guckenheimer', '05/02/1994', 32000.00,  622);
INSERT INTO SAMPLEEMP (EMPID,LNAME,FNAME,HIREDATE,SALARY,DEPTID) VALUES (146, 'Lynn',        'Kemper',       '10/31/1997', 56000.00,  622);


//
// Values for SAMPLEDEPTID :
//
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 000, 'Corporate Headquarters');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 100, 'Sales and Marketing');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 600, 'Engineering');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 900, 'Finance');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 180, 'Marketing');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 620, 'Software Products Div.');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 621, 'Software Development');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 622, 'Quality Assurance');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 623, 'Customer Support');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 670, 'Consumer Electronics Div.');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 671, 'Research and Development');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 672, 'Customer Services');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 130, 'Field Office: East Coast');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 140, 'Field Office: Canada');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 110, 'Pacific Rim Headquarters');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 115, 'Field Office: Japan');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 116, 'Field Office: Singapore');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 120, 'European Headquarters');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 121, 'Field Office: Switzerland');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 123, 'Field Office: France');
INSERT INTO SAMPLEDEPT (DEPTID, DNAME) VALUES ( 125, 'Field Office: Italy');
