// $Header: z:/admin/jb20_samples.English/borland/samples/NativeExample/jni/rcs/typedefs_md.h 1.1 1998/02/18 20:24:01 ghamer Exp $ 
/*
 * @(#)typedefs_md.h	1.23 97/01/23
 *
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1_beta
 *
 */

/*
 * Win32 dependent type definitions
 */

#ifndef _WIN32_TYPEDEF_MD_H_
#define _WIN32_TYPEDEF_MD_H_

#include <windows.h>

#include "bool.h"

typedef unsigned int uint_t;
typedef long int32_t;
typedef unsigned long uint32_t;

#if defined(__BORLANDC__) && (!defined(_INTEGRAL_MAX_BITS) || _INTEGRAL_MAX_BITS < 64)

typedef struct int64_t {
    long int64L;
    long int64H;
} int64_t;

/* uint64_t is not used and therefore not defined */

#define 		ll_high(a)	((a).int64H)
#define 		ll_low(a)	((a).int64L)
int64_t __fastcall	int2ll(long n);
#define 		ll2int(a)	((int)((a).int64L))
int64_t __fastcall	ll_add(int64_t a, int64_t b);
int64_t __fastcall	ll_and(int64_t a, int64_t b);
int64_t __fastcall	ll_div(int64_t a, int64_t b);
int64_t __fastcall	ll_mul(int64_t a, int64_t b);
int64_t __fastcall	ll_neg(int64_t a);
int64_t __fastcall	ll_not(int64_t a);
int64_t __fastcall	ll_or(int64_t a, int64_t b);
int64_t __fastcall	ll_shl(int64_t a, long n);
int64_t __fastcall	ll_shr(int64_t a, long n);
int64_t __fastcall	ll_sub(int64_t a, int64_t b);
int64_t __fastcall	ll_ushr(int64_t a, long n);
int64_t __fastcall	ll_xor(int64_t a, int64_t b);
int64_t __fastcall	uint2ll(unsigned long n);
int64_t __fastcall	ll_rem(int64_t a, int64_t b);

int64_t __fastcall	float2ll(float f);
int64_t __fastcall	double2ll(double d);
float __fastcall	ll2float(int64_t a);
double __fastcall	ll2double(int64_t a);

/* comparison operators */
#define ll_ltz(a)	((a).int64H < 0)
#define ll_gez(a)	((a).int64H >= 0)
int __fastcall		ll_eqz(int64_t a);
int __fastcall		ll_eq(int64_t a, int64_t b);
int __fastcall		ll_ne(int64_t a, int64_t b);
int __fastcall		ll_ge(int64_t a, int64_t b);
int __fastcall		ll_le(int64_t a, int64_t b);
int __fastcall		ll_lt(int64_t a, int64_t b);
int __fastcall		ll_gt(int64_t a, int64_t b);

int64_t __fastcall	ll_zero_const(void);
int64_t __fastcall	ll_one_const(void);

#else

typedef __int64 int64_t;
typedef unsigned __int64 uint64_t;

/* use these macros when the compiler supports the long long type */

#define ll_high(a)	((long)((a)>>32))
#define ll_low(a)	((long)(a))
#define int2ll(a)	((int64_t)(a))
#define ll2int(a)	((int)(a))
#define ll_add(a, b)	((a) + (b))
#define ll_and(a, b)	((a) & (b))
#define ll_div(a, b)	((a) / (b))
#define ll_mul(a, b)	((a) * (b))
#define ll_neg(a)	(-(a))
#define ll_not(a)	(~(a))
#define ll_or(a, b)	((a) | (b))
/* THE FOLLOWING DEFINITION IS NOW A FUNCTION CALL IN ORDER TO WORKAROUND
   OPTIMIZER BUG IN MSVC++ 2.1 (see system_md.c)
   #define ll_shl(a, n)	((a) << (n)) */
#define ll_shr(a, n)	((a) >> (n))
#define ll_sub(a, b)	((a) - (b))
#define ll_ushr(a, n)	((uint64_t)(a) >> (n))
#define ll_xor(a, b)	((a) ^ (b))
#define uint2ll(a)	((uint64_t)(unsigned long)(a))
#define ll_rem(a,b)	((a) % (b))

int64_t float2ll(float f);
#define ll2float(a)	((float) (a))
#define ll2double(a)	((double) (a))
int64_t double2ll(double f);

/* comparison operators */
#define ll_ltz(ll)	((ll) < 0)
#define ll_gez(ll)	((ll) >= 0)
#define ll_eqz(a)	((a) == 0)
#define ll_eq(a, b)	((a) == (b))
#define ll_ne(a,b)	((a) != (b))
#define ll_ge(a,b)	((a) >= (b))
#define ll_le(a,b)	((a) <= (b))
#define ll_lt(a,b)	((a) < (b))
#define ll_gt(a,b)	((a) > (b))

#define ll_zero_const	((int64_t) 0)
#define ll_one_const	((int64_t) 1)

extern int64_t ll_shl(int64_t a, int bits);

#endif

int32_t float2l(float f);
int32_t double2l(double f);

extern void ll2str(int64_t a, char *s, char *limit);

#include <stdlib.h>	/* For malloc() and free() */

#endif /* !_WIN32_TYPEDEF_MD_H_ */
